"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.fn_a1f9a = void 0;
var tslib_1 = require("tslib");
var helpers_1 = require("../../helpers");
var assertions_1 = require("../../helpers/assertions");
var tools_1 = require("../../helpers/tools");
var fulfillementBlock_1 = require("./fulfillementBlock");
var makeRejection_1 = require("./makeRejection");
var makeSettler_1 = require("./makeSettler");
var isPromiseFulfilledResult = helpers_1.assertions.isPromiseFulfilledResult, isPromiseRejectedResult = helpers_1.assertions.isPromiseRejectedResult, isPromiseSettledResult = helpers_1.assertions.isPromiseSettledResult;
// FUNC DEF:(fn_a1f9a<T, R>) -----------------------------------------
/** @internal */
function fn_a1f9a(_a) {
    var _this = this;
    var item = _a.item, index = _a.index, array = _a.array, _b = _a.transform, transform = _b === void 0 ? function (value) { return tslib_1.__awaiter(_this, void 0, void 0, function () { return tslib_1.__generator(this, function (_a) {
        return [2 /*return*/, value];
    }); }); } : _b, _c = _a.lookup, lookup = _c === void 0 ? function (value, index, array) { return void [value, index, array]; } : _c, _d = _a.validate, validate = _d === void 0 ? function (value, index, array) { return tslib_1.__awaiter(_this, void 0, void 0, function () { return tslib_1.__generator(this, function (_a) {
        return [2 /*return*/, void [value, index, array]];
    }); }); } : _d, _e = _a.errLookup, errLookup = _e === void 0 ? function (value, index, currentRejection) {
        return void [value, index, currentRejection];
    } : _e;
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var transformStep, myItem, _f, _g, currentRejection, reason, reason_1, currentRejection;
        return tslib_1.__generator(this, function (_h) {
            switch (_h.label) {
                case 0:
                    transformStep = (0, tools_1.getTransformStep)(item, 0);
                    _f = makeSettler_1.makeSettler;
                    if (!(0, assertions_1.isPromiseLike)(item)) return [3 /*break*/, 2];
                    return [4 /*yield*/, item];
                case 1:
                    _g = _h.sent();
                    return [3 /*break*/, 3];
                case 2:
                    _g = item;
                    _h.label = 3;
                case 3:
                    myItem = _f.apply(void 0, [_g, index]);
                    _h.label = 4;
                case 4:
                    _h.trys.push([4, 7, , 8]);
                    if (!(!isPromiseSettledResult(myItem) || isPromiseFulfilledResult(myItem))) return [3 /*break*/, 6];
                    return [4 /*yield*/, (0, fulfillementBlock_1.fulfillementBlock)(myItem, index, array, transform, lookup, validate)];
                case 5: return [2 /*return*/, _h.sent()];
                case 6:
                    if (isPromiseRejectedResult(myItem)) {
                        currentRejection = false;
                        reason = myItem.reason;
                        void errLookup(reason, index, currentRejection);
                        return [2 /*return*/, (0, makeRejection_1.makeRejection)({
                                reason: reason,
                                index: index,
                                transformStep: (0, tools_1.getTransformStep)(myItem, 0),
                                currentRejection: currentRejection,
                                base: myItem,
                            })];
                    }
                    /* istanbul ignore next */
                    throw new TypeError("NEVER: item (".concat(myItem, ") is not assignable to type 'never'"));
                case 7:
                    reason_1 = _h.sent();
                    currentRejection = true;
                    void errLookup(reason_1, index, currentRejection);
                    return [2 /*return*/, (0, makeRejection_1.makeRejection)({
                            reason: reason_1,
                            index: index,
                            transformStep: transformStep,
                            currentRejection: currentRejection,
                            base: myItem,
                        })];
                case 8: return [2 /*return*/];
            }
        });
    });
}
exports.fn_a1f9a = fn_a1f9a;
// TASK LIST: [TODO] (Review Documentation) --------------------------
//# sourceMappingURL=fn_a1f9a.js.map