"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.fulfillementBlock = void 0;
var tslib_1 = require("tslib");
var makeFulfillement_1 = require("./makeFulfillement");
// FUNC DEF:(fulfillementBlock<T, R>) ----------------------------------------
/** @internal */
function fulfillementBlock(item, index, array, transformFn, lookupFn, validateFn) {
    var _this = this;
    if (transformFn === void 0) { transformFn = function (value) { return tslib_1.__awaiter(_this, void 0, void 0, function () { return tslib_1.__generator(this, function (_a) {
        return [2 /*return*/, value];
    }); }); }; }
    if (lookupFn === void 0) { lookupFn = function (value, index, array) {
        return void [value, index, array];
    }; }
    if (validateFn === void 0) { validateFn = function (value, index, array) { return tslib_1.__awaiter(_this, void 0, void 0, function () { return tslib_1.__generator(this, function (_a) {
        return [2 /*return*/, void [value, index, array]];
    }); }); }; }
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var transformation, value, transformStep;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    transformation = transformFn(item.value, index, array);
                    return [4 /*yield*/, transformation];
                case 1:
                    value = _a.sent();
                    void lookupFn(value, index, array);
                    return [4 /*yield*/, validateFn(value, index, array)];
                case 2:
                    _a.sent();
                    transformStep = item.transformStep;
                    transformStep++;
                    return [2 /*return*/, (0, makeFulfillement_1.makeFulfillement)({ value: value, index: index, transformStep: transformStep })];
            }
        });
    });
}
exports.fulfillementBlock = fulfillementBlock;
// TASK LIST: [TODO] (Review Documentation) --------------------------
//# sourceMappingURL=fulfillementBlock.js.map