"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeFulfillement = void 0;
var tslib_1 = require("tslib");
var constants_1 = require("../../constants");
// FUNC DEF:(makeFulfillement<U>) ------------------------------------
/** @internal */
function makeFulfillement(_a) {
    var value = _a.value, _b = _a.transformStep, transformStep = _b === void 0 ? -1 : _b, _c = _a.index, index = _c === void 0 ? -1 : _c, _d = _a.base, base = _d === void 0 ? {} : _d;
    var currentValue = Object.freeze(value);
    var currentSettlement = {
        status: constants_1.FULFILLED,
        value: currentValue,
    };
    var currentIndex = base != null &&
        typeof base === 'object' &&
        'index' in base &&
        base.index != null &&
        typeof base.index === 'number' &&
        base.index > -1 &&
        !isNaN(base.index)
        ? base.index
        : typeof index === 'number' && !isNaN(index)
            ? index
            : -1;
    // INFO: To get base properties last but also overide its values ...
    var result = tslib_1.__assign(tslib_1.__assign(tslib_1.__assign(tslib_1.__assign({}, currentSettlement), base), currentSettlement), { fulfilled: currentValue, currentRejection: null, rejected: null, reason: undefined, index: currentIndex, transformStep: transformStep });
    Object.defineProperty(result, 'reason', {
        value: undefined,
        enumerable: false,
        writable: false,
    });
    Object.defineProperty(result, 'value', {
        value: currentValue,
        enumerable: true,
        writable: false,
    });
    Object.defineProperty(result, 'fulfilled', {
        value: currentValue,
        enumerable: false,
        writable: false,
    });
    Object.defineProperty(result, 'rejected', {
        value: null,
        enumerable: false,
        writable: false,
    });
    Object.defineProperty(result, 'currentRejection', {
        value: null,
        enumerable: false,
        writable: false,
    });
    if (transformStep === -1) {
        Object.defineProperty(result, 'transformStep', {
            value: transformStep,
            enumerable: false,
            writable: false,
        });
    }
    else {
        Object.defineProperty(result, 'transformStep', {
            value: transformStep,
            enumerable: true,
            writable: false,
        });
    }
    if (currentIndex === -1) {
        Object.defineProperty(result, 'index', {
            value: currentIndex,
            enumerable: false,
            writable: false,
        });
    }
    // else {
    //   Object.defineProperty(result, 'index', {
    //     value: currentIndex,
    //     enumerable: true,
    //     writable: false,
    //   });
    // }
    return Object.freeze(result);
}
exports.makeFulfillement = makeFulfillement;
// TASK LIST: [TODO] (Review Documentation) --------------------------
//# sourceMappingURL=makeFulfillement.js.map