"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateMapping = void 0;
var tslib_1 = require("tslib");
var core_1 = require("./core");
/**
 * @beta
 */
function generateMapping(collection, transformFn, lookupFn, validateFn, errLookupFn) {
    var index, collection_1, collection_1_1, item, e_1_1;
    var e_1, _a;
    var _this = this;
    if (transformFn === void 0) { transformFn = function (value) { return tslib_1.__awaiter(_this, void 0, void 0, function () { return tslib_1.__generator(this, function (_a) {
        return [2 /*return*/, value];
    }); }); }; }
    if (lookupFn === void 0) { lookupFn = function (v) { return void v; }; }
    if (validateFn === void 0) { validateFn = function (v) { return tslib_1.__awaiter(_this, void 0, void 0, function () { return tslib_1.__generator(this, function (_a) {
        return [2 /*return*/, void v];
    }); }); }; }
    if (errLookupFn === void 0) { errLookupFn = function (v) { return void v; }; }
    return tslib_1.__generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                index = 0;
                _b.label = 1;
            case 1:
                _b.trys.push([1, 6, 7, 8]);
                collection_1 = tslib_1.__values(collection), collection_1_1 = collection_1.next();
                _b.label = 2;
            case 2:
                if (!!collection_1_1.done) return [3 /*break*/, 5];
                item = collection_1_1.value;
                return [4 /*yield*/, (0, core_1.fn_a1f9a)({
                        item: item,
                        index: index++,
                        array: tslib_1.__spreadArray([], tslib_1.__read(collection), false),
                        transform: transformFn == null ? function (value) { return tslib_1.__awaiter(_this, void 0, void 0, function () { return tslib_1.__generator(this, function (_a) {
                            return [2 /*return*/, value];
                        }); }); } : transformFn,
                        lookup: lookupFn == null ? function (v) { return void v; } : lookupFn,
                        validate: validateFn == null ? function (v) { return tslib_1.__awaiter(_this, void 0, void 0, function () { return tslib_1.__generator(this, function (_a) {
                            return [2 /*return*/, void v];
                        }); }); } : validateFn,
                        errLookup: errLookupFn == null ? function (v) { return void v; } : errLookupFn,
                    })];
            case 3:
                _b.sent();
                _b.label = 4;
            case 4:
                collection_1_1 = collection_1.next();
                return [3 /*break*/, 2];
            case 5: return [3 /*break*/, 8];
            case 6:
                e_1_1 = _b.sent();
                e_1 = { error: e_1_1 };
                return [3 /*break*/, 8];
            case 7:
                try {
                    if (collection_1_1 && !collection_1_1.done && (_a = collection_1.return)) _a.call(collection_1);
                }
                finally { if (e_1) throw e_1.error; }
                return [7 /*endfinally*/];
            case 8: return [2 /*return*/];
        }
    });
}
exports.generateMapping = generateMapping;
// TASK LIST: [TODO] (Review Documentation) --------------------------
//# sourceMappingURL=generateMapping.js.map