"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parallelMapping = void 0;
var tslib_1 = require("tslib");
var core_1 = require("./core");
/**
 * @beta
 */
function parallelMapping(collection, transformFn, lookupFn, validateFn, errLookupFn) {
    var _this = this;
    if (transformFn === void 0) { transformFn = function (value) { return tslib_1.__awaiter(_this, void 0, void 0, function () { return tslib_1.__generator(this, function (_a) {
        return [2 /*return*/, value];
    }); }); }; }
    if (lookupFn === void 0) { lookupFn = function (v) { return void v; }; }
    if (validateFn === void 0) { validateFn = function (v) { return tslib_1.__awaiter(_this, void 0, void 0, function () { return tslib_1.__generator(this, function (_a) {
        return [2 /*return*/, void v];
    }); }); }; }
    if (errLookupFn === void 0) { errLookupFn = function (v) { return void v; }; }
    return tslib_1.__spreadArray([], tslib_1.__read(collection), false).map(function (item, index, array) {
        return (0, core_1.fn_a1f9a)({
            item: item,
            index: index,
            array: array,
            transform: transformFn == null ? function (value) { return tslib_1.__awaiter(_this, void 0, void 0, function () { return tslib_1.__generator(this, function (_a) {
                return [2 /*return*/, value];
            }); }); } : transformFn,
            lookup: lookupFn == null ? function (v) { return void v; } : lookupFn,
            validate: validateFn == null ? function (v) { return tslib_1.__awaiter(_this, void 0, void 0, function () { return tslib_1.__generator(this, function (_a) {
                return [2 /*return*/, void v];
            }); }); } : validateFn,
            errLookup: errLookupFn == null ? function (v) { return void v; } : errLookupFn,
        });
    });
}
exports.parallelMapping = parallelMapping;
// TASK LIST: [TODO] (Review Documentation) --------------------------
//# sourceMappingURL=parallelMapping.js.map