"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeRejection = void 0;
var tslib_1 = require("tslib");
var constants_1 = require("../../constants");
// FUNC DEF:(makeRejection) ------------------------------------------
/** @internal */
function makeRejection(_a) {
    var reason = _a.reason, _b = _a.currentRejection, currentRejection = _b === void 0 ? undefined : _b, _c = _a.transformStep, transformStep = _c === void 0 ? -1 : _c, _d = _a.index, index = _d === void 0 ? -1 : _d, _e = _a.base, base = _e === void 0 ? {} : _e;
    var currentReason = Object.freeze(reason);
    var currentSettlement = {
        status: constants_1.REJECTED,
        reason: currentReason,
    };
    // INFO: To get base properties last but also overide its values ...
    var result = tslib_1.__assign(tslib_1.__assign(tslib_1.__assign(tslib_1.__assign(tslib_1.__assign({}, currentSettlement), { currentRejection: currentRejection }), base), currentSettlement), { rejected: currentReason, fulfilled: null, value: undefined, transformStep: transformStep, index: index });
    Object.defineProperty(result, 'reason', {
        value: currentReason,
        enumerable: true,
        writable: false,
    });
    Object.defineProperty(result, 'value', {
        value: undefined,
        enumerable: false,
        writable: false,
    });
    Object.defineProperty(result, 'rejected', {
        value: currentReason,
        enumerable: false,
        writable: false,
    });
    Object.defineProperty(result, 'fulfilled', {
        value: null,
        enumerable: false,
        writable: false,
    });
    if (transformStep === -1) {
        Object.defineProperty(result, 'transformStep', {
            value: transformStep,
            enumerable: false,
            writable: false,
        });
    }
    if (index === -1) {
        Object.defineProperty(result, 'index', {
            value: index,
            enumerable: false,
            writable: false,
        });
    }
    return Object.freeze(result);
}
exports.makeRejection = makeRejection;
// TASK LIST: [TODO] (Review Documentation) --------------------------
//# sourceMappingURL=makeRejection.js.map