"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateMappingAsync = void 0;
var tslib_1 = require("tslib");
var core_1 = require("./core");
/**
 * @beta
 */
function generateMappingAsync(collection, transformFn, lookupFn, validateFn, errLookupFn) {
    var _this = this;
    if (transformFn === void 0) { transformFn = function (value) { return tslib_1.__awaiter(_this, void 0, void 0, function () { return tslib_1.__generator(this, function (_a) {
        return [2 /*return*/, value];
    }); }); }; }
    if (lookupFn === void 0) { lookupFn = function (v) { return void v; }; }
    if (validateFn === void 0) { validateFn = function (v) { return tslib_1.__awaiter(_this, void 0, void 0, function () { return tslib_1.__generator(this, function (_a) {
        return [2 /*return*/, void v];
    }); }); }; }
    if (errLookupFn === void 0) { errLookupFn = function (v) { return void v; }; }
    return tslib_1.__asyncGenerator(this, arguments, function generateMappingAsync_1() {
        var index, _a, collection_1, collection_1_1, item, e_1_1;
        var _this = this;
        var _b, e_1, _c, _d;
        return tslib_1.__generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    index = 0;
                    _e.label = 1;
                case 1:
                    _e.trys.push([1, 10, 11, 16]);
                    _a = true, collection_1 = tslib_1.__asyncValues(collection);
                    _e.label = 2;
                case 2: return [4 /*yield*/, tslib_1.__await(collection_1.next())];
                case 3:
                    if (!(collection_1_1 = _e.sent(), _b = collection_1_1.done, !_b)) return [3 /*break*/, 9];
                    _d = collection_1_1.value;
                    _a = false;
                    _e.label = 4;
                case 4:
                    _e.trys.push([4, , 7, 8]);
                    item = _d;
                    return [4 /*yield*/, tslib_1.__await((0, core_1.fn_a1f9a)({
                            item: item,
                            index: index++,
                            array: tslib_1.__spreadArray([], tslib_1.__read(collection), false),
                            transform: transformFn == null ? function (value) { return tslib_1.__awaiter(_this, void 0, void 0, function () { return tslib_1.__generator(this, function (_a) {
                                return [2 /*return*/, value];
                            }); }); } : transformFn,
                            lookup: lookupFn == null ? function (v) { return void v; } : lookupFn,
                            validate: validateFn == null ? function (v) { return tslib_1.__awaiter(_this, void 0, void 0, function () { return tslib_1.__generator(this, function (_a) {
                                return [2 /*return*/, void v];
                            }); }); } : validateFn,
                            errLookup: errLookupFn == null ? function (v) { return void v; } : errLookupFn,
                        }))];
                case 5: return [4 /*yield*/, _e.sent()];
                case 6:
                    _e.sent();
                    return [3 /*break*/, 8];
                case 7:
                    _a = true;
                    return [7 /*endfinally*/];
                case 8: return [3 /*break*/, 2];
                case 9: return [3 /*break*/, 16];
                case 10:
                    e_1_1 = _e.sent();
                    e_1 = { error: e_1_1 };
                    return [3 /*break*/, 16];
                case 11:
                    _e.trys.push([11, , 14, 15]);
                    if (!(!_a && !_b && (_c = collection_1.return))) return [3 /*break*/, 13];
                    return [4 /*yield*/, tslib_1.__await(_c.call(collection_1))];
                case 12:
                    _e.sent();
                    _e.label = 13;
                case 13: return [3 /*break*/, 15];
                case 14:
                    if (e_1) throw e_1.error;
                    return [7 /*endfinally*/];
                case 15: return [7 /*endfinally*/];
                case 16: return [2 /*return*/];
            }
        });
    });
}
exports.generateMappingAsync = generateMappingAsync;
// TASK LIST: [TODO] (Review Documentation) --------------------------
//# sourceMappingURL=generateMappingAsync.js.map